﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DataExchange
{
    public partial class DlgOptions : Form, IFavoriteColor
    {
        public DlgOptions()
        {
            InitializeComponent();
            this.colorDialogFavorite = new ColorDialog(); 
            this.colorUnapplied = this.FavoriteColor;
        }

        private void buttonFavorite_Click(object sender, EventArgs e)
        {
            this.colorDialogFavorite.Color = FavoriteColor;
            this.colorDialogFavorite.ShowDialog();
            FavoriteColor = colorDialogFavorite.Color;
        }


        private void DlgOptions_Load(object sender, EventArgs e)
        {
            this.buttonFavorite.BackColor = FavoriteColor;
            colorUnapplied = FavoriteColor;
            if (this.Modal)
            {
                buttonApply.Visible = false;
            }
        }

        private void buttonApply_Click(object sender, EventArgs e)
        {
            if (Apply != null)
            {
                Apply(this, EventArgs.Empty);
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (!this.Modal)
            {
                buttonApply_Click(sender, e);
            }
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.FavoriteColor = this.colorUnapplied;
            if (!this.Modal)
            {
                buttonApply_Click(sender, e);
            }
            this.Close();
        }

        Color colorUnapplied;

        #region IFavoriteColorDlg Members

        public Color FavoriteColor
        {
            get
            {
                return buttonFavorite.BackColor;
            }
            set
            {
                buttonFavorite.BackColor = value;
            }
        }

        public event EventHandler Apply;

        #endregion

    }
}
