﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DataExchange
{
    public partial class FormMain : Form
    {
        public FormMain()
        {
            InitializeComponent();
        }

        public Color FavoriteColor
        {
            get
            {
                return Properties.Settings.Default.Color;
            }
            set
            {
                this.buttonModal.BackColor = value;
                this.buttonModeless.BackColor = value;   
                Properties.Settings.Default.Color = value;
            }
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            FavoriteColor = FavoriteColor;
        }

        private void initModalDialog(IFavoriteColor dlg)
        {
            dlg.FavoriteColor = this.FavoriteColor;
        }

        private void retrieveModalDialog(IFavoriteColor dlg)
        {
            this.FavoriteColor = dlg.FavoriteColor;
        }

        private void buttonModal_Click(object sender, EventArgs e)
        {
            using (DlgOptions dlg = new DlgOptions())
            {
                initModalDialog(dlg);
                dlg.ShowDialog();
                if (DialogResult.OK == dlg.DialogResult)
                {
                    retrieveModalDialog(dlg);
                }
            }
        }

        private void initModelessDialog(IFavoriteColor dlg)
        {
            dlg.FavoriteColor = this.FavoriteColor;
            dlg.Apply += new EventHandler(favDlg_Apply);
        }

        private void buttonModeless_Click(object sender, EventArgs e)
        {
            DlgOptions dlg = new DlgOptions();
            initModelessDialog(dlg);
            dlg.Show(this);
        }

        void favDlg_Apply(object sender, EventArgs e)
        {
            IFavoriteColor favDlg = sender as IFavoriteColor;
            if (favDlg != null)
            {
                this.FavoriteColor = favDlg.FavoriteColor;
            }
        }

        private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (MessageBox.Show("Do you want to save the favorite color?", "Save Favorite Color?",
                MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                Properties.Settings.Default.Save();
            }
        }

    }
}
